
local AutoRoller = LibStub('AceAddon-3.0'):NewAddon('BrokerScriptLauncher', 'AceEvent-3.0', 'AceConsole-3.0')
_G.AutoRoller = AutoRoller

local chatFrame = DEFAULT_CHAT_FRAME
local format = string.format

---------------   initialize   ---------------

local defaults = {
   profile = {
      enabled = true,
      boe = "greed",
      bop = "pass",
      recipe = "nothing",
--~       rules = {
--~          GreedGreenBoE = {
--~             enabled = true,

--~          },
--~       },
      chat = true,
   },
}

function AutoRoller:OnInitialize()
   self.db = LibStub('AceDB-3.0'):New('AutoRollerDB', defaults, 'Default')

--~    self.db.RegisterCallback(self, 'OnProfileChanged', 'RefreshConfig')
--~    self.db.RegisterCallback(self, 'OnProfileCopied', 'RefreshConfig')
--~    self.db.RegisterCallback(self, 'OnProfileReset', 'RefreshConfig')

	self:RegisterOptions()
end

function AutoRoller:OnEnable()
   if not self.db.profile.enabled then
      self:Disable()
      return
   end

   return self:RegisterEvent('START_LOOT_ROLL')
end

function AutoRoller:OnDisable()
end

---------------   events   ---------------

function AutoRoller:START_LOOT_ROLL(event, arg1)
		-- arg1 == rollID
   local texture, name, count, quality, isBoP = GetLootRollItemInfo(arg1)
   local link = GetLootRollItemLink(arg1)
   local _,_,_,_,_, itemType = GetItemInfo(link) -- cant use name (item must be in inventory)
--~    local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(link);

   local roll, val

   local db = self.db.profile

   if itemType == 'Recipe' then
      val = db.recipe
   else
      if isBoP == 1 then
         val = db.bop
      else
         val = db.boe
      end
   end

   --RollOnLoot(arg1, {0 : pass, 1 : need, 2 : greed})

   if val == "pass" then
      roll = 0
   elseif val == "need" then
      roll = 1
   elseif val == "greed" then
      roll = 2
   else
      return
   end

   if db.chat then
      chatFrame:AddMessage(format("|cff00AA00AutoRoller: rolling|r %s |cff00AA00on|r %s", val, link))
   end

   return RollOnLoot(arg1, roll)
end

AutoRoller.dataobj = LibStub:GetLibrary('LibDataBroker-1.1'):NewDataObject('AutoLauncher', {
   type = 'launcher',
   icon = 'Interface\\Buttons\\UI-GroupLoot-Dice-Up',
   tocname = 'AutoRoller',
   label = 'AutoRoller',
   OnTooltipShow = function(tooltip)
      tooltip:AddLine("AutoRoller")
      local profile = AutoRoller.db.profile
      local enabled = profile.enabled
      local red = enabled and 0 or 1
      tooltip:AddDoubleLine("Enabled", enabled and "True" or "False", 0, 1, 0, red, 1 - red, 0)
      enabled = profile.chat
      red = enabled and 0 or 1
      tooltip:AddDoubleLine("Chat", enabled and "True" or "False", 0, 1, 0, red, 1 - red, 0)

      tooltip:AddDoubleLine("BoE", profile.boe, 0, 1, 0, 1, 1, 1)
      tooltip:AddDoubleLine("BoP", profile.bop, 0, 1, 0, 1, 1, 1)
      tooltip:AddDoubleLine("Recipe", profile.recipe, 0, 1, 0, 1, 1, 1)
   end,
})